SystemOrganization addCategory: #Kozen!

Object subclass: #Citeseer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!Citeseer commentStamp: 'DamienCassou 1/6/2012 18:39' prior: 0!
Get the rank of someone in the Citeseer author's citation ranking (http://citeseerx.ist.psu.edu/stats/authors?all=true).

For example:

Citeseer rankOf: 'S. Ducasse'!

!Citeseer class methodsFor: 'public' stamp: ''!
rankOf: aName
	"self rankOf: 'S. Ducasse'"
	^ self new rankOf: aName! !

!Citeseer methodsFor: 'operation' stamp: ''!
getCiteseerPage
	^ ZnHttpClient new
		url: 'http://citeseerx.ist.psu.edu/stats/authors';
		parameterAt: 'all' put: 'true';
		get! !

!Citeseer methodsFor: 'operation' stamp: ''!
getRankFrom: page stoppingAt: aString
	| count |
	count := 0.
	page
		regex: '<li>[[:space:]]*<span class="authors">[^>]+>([^<]+)'
		matchesDo: [:match | (match matchesRegex: ('.*', aString, '$'))
								ifTrue: [^ count + 1]
								ifFalse: [count := count + 1]].
	^ Error signal: aString, ' not found in page'! !

!Citeseer methodsFor: 'operation' stamp: ''!
rankOf: aName
	| content rank |
	content := self getCiteseerPage.
	rank := self getRankFrom: content stoppingAt: aName.
	^ rank ! !

Object subclass: #KZObject
	instanceVariableNames: 'value siteId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZObject commentStamp: '<historical>' prior: 0!
A KZObject is the root of Kozen object : objects that models a web site.!

KZObject subclass: #KZImage
	instanceVariableNames: 'image'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZImage commentStamp: '<historical>' prior: 0!
A KZImage is a simple image!

!KZImage methodsFor: 'visiting' stamp: ''!
acceptVisitor: aVisitor

	aVisitor visitImage: self.
! !

!KZImage methodsFor: 'accessing' stamp: ''!
image
	^ image! !

!KZImage methodsFor: 'accessing' stamp: ''!
image: anObject
	image := anObject! !

KZImage subclass: #KZLinkedImage
	instanceVariableNames: 'link'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZLinkedImage commentStamp: '<historical>' prior: 0!
A KZLinkedImage is an image associated with a link.
!

!KZLinkedImage methodsFor: 'visit' stamp: ''!
acceptVisitor: aVisitor

	aVisitor visitLinkedImage: self! !

!KZLinkedImage methodsFor: 'accessing' stamp: ''!
link
	^ link! !

!KZLinkedImage methodsFor: 'accessing' stamp: ''!
link: anObject
	link := anObject! !

KZObject subclass: #KZItem
	instanceVariableNames: 'name link'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZItem commentStamp: '<historical>' prior: 0!
A KZItem is item of menu or menu like list.!

KZItem subclass: #KZBlockItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZBlockItem commentStamp: 'StephaneDucasse 1/3/2012 23:00' prior: 0!
ARBlockItem is an item of a floating block. For example like on the right of my web page.!

!KZBlockItem methodsFor: 'visit' stamp: ''!
acceptVisitor: aVisitor

	aVisitor visitRightBlockItem: self.
! !

!KZItem methodsFor: 'visit' stamp: ''!
acceptVisitor: aVisitor

	aVisitor visitItem: self.! !

!KZItem methodsFor: 'accessing' stamp: ''!
link
	
	^ link! !

!KZItem methodsFor: 'accessing' stamp: ''!
link: aName

	link := aName! !

!KZItem methodsFor: 'accessing' stamp: ''!
name

	^ name! !

!KZItem methodsFor: 'accessing' stamp: ''!
name:  aString

	name := aString! !

KZItem subclass: #KZMenuItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZMenuItem commentStamp: '<historical>' prior: 0!
A KZMenuItem is item for menu navigation!

!KZMenuItem methodsFor: 'visitor' stamp: ''!
acceptVisitor: aVisitor

	aVisitor visitMenuItem: self.
! !

KZObject subclass: #KZList
	instanceVariableNames: 'elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZList commentStamp: '<historical>' prior: 0!
A KZList is sequence of more elements!

KZList subclass: #KZDivBlock
	instanceVariableNames: 'attribute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZDivBlock commentStamp: 'StephaneDucasse 1/5/2012 22:15' prior: 0!
<div id="header">
	attribute = id 
	value = header
	
	and nested components
	
!

!KZDivBlock methodsFor: 'visiting' stamp: ''!
acceptVisitor: aVisitor

	aVisitor visitDivBlock: self.
! !

!KZDivBlock methodsFor: 'accessing' stamp: ''!
attribute
	^ attribute! !

!KZDivBlock methodsFor: 'accessing' stamp: ''!
attribute: aString
	
	attribute := aString! !

!KZList methodsFor: 'visit' stamp: ''!
acceptVisitor: aVisitor

	aVisitor visitItemList: self! !

!KZList methodsFor: 'elements' stamp: ''!
addElement: anElement

	elements add: anElement! !

!KZList methodsFor: 'elements' stamp: ''!
elements

	^ elements! !

!KZList methodsFor: 'initialize' stamp: ''!
initialize

	super initialize.
	elements := OrderedCollection new.! !

KZList subclass: #KZMenu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZMenu commentStamp: '<historical>' prior: 0!
A KZMenu is menu holdeing several menu items!

!KZMenu methodsFor: 'visit' stamp: ''!
acceptVisitor: aVisitor

	aVisitor visitMenu: self.
! !

KZList subclass: #KZResearchTopic
	instanceVariableNames: 'text bibItems'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZResearchTopic commentStamp: '<historical>' prior: 0!
A KZResearchTopic is a list of CZEntries!

KZList subclass: #KZRightBlock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZRightBlock commentStamp: '<historical>' prior: 0!
A KZRightBlock is kind of navigation bar!

!KZRightBlock methodsFor: 'visit' stamp: ''!
acceptVisitor: aVisitor

	aVisitor visitRightBlock: self.! !

KZList subclass: #KZSection
	instanceVariableNames: 'levelNumber title text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZSection commentStamp: '<historical>' prior: 0!
A KZSection is a section with a title and a level!

!KZSection methodsFor: 'accessing' stamp: ''!
acceptVisitor: aVisitor

	aVisitor visitSection: self! !

!KZSection methodsFor: 'initialize' stamp: ''!
initialize

	super initialize.
	levelNumber := '2'.! !

!KZSection methodsFor: 'accessing' stamp: ''!
levelDigitString

	^ levelNumber! !

!KZSection methodsFor: 'accessing' stamp: ''!
levelDigitString: aString
	"'2' for h2, '3' for h3...."

	levelNumber := aString! !

!KZSection methodsFor: 'accessing' stamp: ''!
text
	^ text! !

!KZSection methodsFor: 'accessing' stamp: ''!
text: anObject
	text := anObject! !

!KZSection methodsFor: 'accessing' stamp: ''!
title
	^ title! !

!KZSection methodsFor: 'accessing' stamp: ''!
title: anObject
	title := anObject! !

!KZObject methodsFor: 'visiting' stamp: ''!
acceptVisitor: aVisitor
	! !

!KZObject methodsFor: 'accessing' stamp: ''!
siteId
	^ siteId! !

!KZObject methodsFor: 'accessing' stamp: ''!
siteId: anId
	"anId should uniquely identify the receiver"
	siteId := anId! !

!KZObject methodsFor: 'accessing' stamp: ''!
value
	^ value! !

!KZObject methodsFor: 'accessing' stamp: ''!
value: aString
	value := aString! !

KZObject subclass: #KZPage
	instanceVariableNames: 'title elements name main site filename cssFile headerSiteTitle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZPage commentStamp: 'StephaneDucasse 1/18/2012 21:24' prior: 0!
I'm a page and as such I contain elements and I'm saved in a file.!

!KZPage class methodsFor: 'instance creation' stamp: ''!
name: aString filename: aFileName

	^ self new name: aString; filename: aFileName; yourself! !

!KZPage methodsFor: 'visiting' stamp: ''!
acceptVisitor: aVisitor

	aVisitor visitPage: self.
! !

!KZPage methodsFor: 'adding' stamp: ''!
addElement: anElement

	elements add: anElement.! !

!KZPage methodsFor: 'adding' stamp: ''!
addElementInMain: anElement

	main addElement: anElement.! !

!KZPage methodsFor: 'accessing' stamp: ''!
cssFile
	^cssFile! !

!KZPage methodsFor: 'accessing' stamp: ''!
cssFile: aString
	
	cssFile := aString! !

!KZPage methodsFor: 'default' stamp: ''!
defaultCSSFile
	^ 'CSS/stef.css'! !

!KZPage methodsFor: 'default' stamp: ''!
defaultName

	^ 'Home'! !

!KZPage methodsFor: 'default' stamp: ''!
defaultTitle

	^ 'The title can also give some information about you' ! !

!KZPage methodsFor: 'accessing' stamp: ''!
elements

	^ elements! !

!KZPage methodsFor: 'accessing' stamp: ''!
filename
	| fn |
	fn := filename isNil
		ifTrue: [ name ]
		ifFalse: [ filename ].
	^ fn , '.html'! !

!KZPage methodsFor: 'accessing' stamp: ''!
filename: aName
	
	filename := aName! !

!KZPage methodsFor: 'accessing' stamp: ''!
head

	^ '<head>
		<link rel="stylesheet" href="' , self cssFile
		,
			'"/>
		<title>' , self title
		,
			'</title>
   </head>'! !

!KZPage methodsFor: 'accessing' stamp: ''!
headerPageTitle

	^ self name
! !

!KZPage methodsFor: 'accessing' stamp: ''!
headerSiteTitle
	"the title inside the page"
	
	^ headerSiteTitle! !

!KZPage methodsFor: 'accessing' stamp: ''!
headerSiteTitle: aString
	"the title inside the page"
	
	headerSiteTitle := aString! !

!KZPage methodsFor: 'initialize-release' stamp: ''!
initialize

	super initialize.
	elements := OrderedCollection new.
	title := self defaultTitle.
	name := self defaultName.
	cssFile := self defaultCSSFile.
	main := KZDivBlock new attribute: 'id' ; value: 'mainContent'.! !

!KZPage methodsFor: 'accessing' stamp: ''!
main
	"describes the main part of the body - related to css may be we should change that but 
	menu should be out and block and section nested in."
	
	^ main! !

!KZPage methodsFor: 'accessing' stamp: ''!
metaHead

	^ '<?xml version="1.0" encoding="ISO-8859-1"?>
	<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">'! !

!KZPage methodsFor: 'accessing' stamp: ''!
name 
	"For example the welcomePage can be called Home "
	^ name! !

!KZPage methodsFor: 'accessing' stamp: ''!
name: aString
	name := aString! !

!KZPage methodsFor: 'printing' stamp: ''!
printOn: aStream

	super printOn: aStream.
	aStream space.
	aStream nextPutAll: self name. ! !

!KZPage methodsFor: 'accessing' stamp: ''!
site

	^ site! !

!KZPage methodsFor: 'accessing' stamp: ''!
site:  aSite

	site := aSite! !

!KZPage methodsFor: 'accessing' stamp: ''!
title

	^ title ! !

!KZPage methodsFor: 'accessing' stamp: ''!
title: aString

	title := aString! !

Object subclass: #KZSite
	instanceVariableNames: 'elements pages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZSite commentStamp: 'StephaneDucasse 2/5/2012 18:29' prior: 0!
A KZSite represents all the information for a site composed by pages. !

!KZSite methodsFor: 'visiting' stamp: ''!
acceptVisitor: aVisitor

	aVisitor visitSite: aVisitor! !

!KZSite methodsFor: 'initialize' stamp: ''!
addPage: aPage

	pages add: aPage! !

!KZSite methodsFor: 'operations' stamp: ''!
declare: anElement withId: anID
	"Declare the element with a given id so that we can link back to it"
	
	elements at: anID put: anElement! !

!KZSite methodsFor: 'operations' stamp: ''!
declarePage: aPage withId: anID
	"Declare a page with a given id for future reference. A page is also added to the site web page."
	elements at: anID put: aPage.
	aPage site: self.
	pages add: aPage.! !

!KZSite methodsFor: 'operations' stamp: ''!
generate
	"self new generate"
	
	| visitor |
	visitor := self visitorClass new.
	visitor visitSite: self site.
	! !

!KZSite methodsFor: 'initialize' stamp: ''!
initialize

	super initialize.
	elements := Dictionary new.
	pages := OrderedCollection new.! !

!KZSite methodsFor: 'operations' stamp: ''!
pages
	^ pages! !

!KZSite methodsFor: 'accessing' stamp: ''!
site

	self subclassResponsibility
	! !

!KZSite methodsFor: 'operations' stamp: ''!
visitorClass

	^  KZVisitor ! !

KZSite subclass: #KzMenuInfoBodySite
	instanceVariableNames: 'bibBuilder cssDirectoryName cssFilename bibSet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KzMenuInfoBodySite commentStamp: 'StephaneDucasse 2/5/2012 17:54' prior: 0!
I'm responsible for building a web site like http://stephane.ducasse.free.fr

I will generate a set of web page (to be customized by the users) as well as a CSS. !

!KzMenuInfoBodySite class methodsFor: 'initialization' stamp: ''!
defaultCSS

 	^ 'body{
	COLOR: #000000; 
	BACKGROUND: #FFFFFF;                                    
	
	font: 10pt Verdana, Tahoma, Arial, Helvetica, sans-serif, Times New Roman;

	PADDING-LEFT: 0px;
	PADDING-RIGHT: 0px;
	PADDING-TOP: 0px;
	PADDING-BOTTOM: 0px;
}


/* HEADER */

#header {
}

#headerSiteTitle {
	font-size: 12pt;
	font-weight: 500;
	letter-spacing: 1px;
	border-bottom: 1px solid #CCCCCC;
	width: 128px;
}


#headerSiteTitle {
	font-size: 12pt;
	font-weight: 500;
	letter-spacing: 1px;
	border-bottom: 1px solid #CCCCCC;
	width: 250px;
}

#headerPageTitle {
	font-size: 10pt;
	font-weight: 500;
	color: #777777;
	letter-spacing: 7px;
	margin-left: 8px;
	padding-left: 48px;
	border-left: 1px solid #CCCCCC
}

/* HEADER - end*/

/* MENU */


#menu {
	float: left;

	margin-left: 8px;
	margin-right: 32px;
	margin-bottom: 16px;
	width: 142px;
}


#toc {
	font-size: 8pt;
	padding-top: 16px;
	border-left: 1px solid #CCCCCC;
}


#tocItem {
	padding: 8px;
	border-bottom: 1px #CCCCCC solid;
}

#copyright {
	font: 7pt Verdana, Tahoma, Arial, Helvetica, sans-serif, Times New Roman;
	color: #777777;
	margin-top: 8px;
	margin-bottom: 8px;
}

/*MENU - end*/

/*MAIN*/

td{
	font: 8pt Verdana, Tahoma, Arial, Helvetica, sans-serif, Times New Roman;
}


#mainContent {
	position: absolute;
	left: 160px;
	margin: 8px;
	margin-top: 0px;
	padding-top: 16px;
	
	font: 9pt Verdana, Tahoma, Arial, Helvetica, sans-serif, Times New Roman;
	
}

#personalDetails {
	font: 7pt Verdana, Tahoma, Arial, Helvetica, sans-serif, Times New Roman;
	float: right;
	width: 128px;
	margin-left: 16px;
	margin-bottom: 16px;
}

#personalDetailsItem{
	margin-left: 8px;
	border-left: 1px solid #CCCCCC;
	border-bottom: 1px solid #CCCCCC;
	padding: 8px;
}

/*MAIN - end*/

/*COMMON*/

#commonList {
}

#commonItem {
	padding-top: 8px;
	padding-bottom: 8px;
}

#commonItemDate {
	font-size: 7pt;
}

#commonItemDate:before {
	content: " ("
}

#commonItemDate:after {
	content: ") "
}

#commonItemTitle {
}

#commonItemDescription {
}

#commonItemDescription:before {
	content: "-"
}

#commonItemDetail {
	font-size: 7pt;
	margin-left: 16px;
}

/*COMMON - end*/


/*PUBLICATIONS*/

.paperList, .projectList, .contactData {
	padding-bottom:32px;
}

.paperListTitle, .projectListTitle, .contactTitle {
	letter-spacing: 2px;
	border-bottom: 1px solid #CCCCCC;
	margin-bottom: 16px;
}

.paper, .project, .supervisedThesis, .presentation {
	padding-bottom: 16px;
}

.paperAbstract, .paperBibEntry, .thesisSupervisor, .thesisAbstract {
	font-size: 7pt;
	margin-left: 16px;
	margin-top: 4px;
}

.paperRef, .thesisRef {
	margin-left: 16px;
	margin-top: 4px;
}

.paperDate, .thesisDate, .projectDate, .presentationDate {
	font-size: 7pt;
}

.paperDate:before, .thesisDate:before, .projectDate:before, .presentationDate:before {
	content: " ("
}

.paperDate:after, .thesisDate:after, .projectDate:after, .presentationDate:after {
	content: ") "
}


.paperDescription:before, .thesisDescription:before, .projectDescription:before, .presentationLocation:before {
	content: "- "
}

.paperAuthor:after, .thesisAuthor:after {
	content: " - "
}

.paperTitle, .thesisTitle {	
	color: #992222;
}

.paperTitle:after, .paperTitle:before, .thesisTitle:after, .thesisTitle:before {
	content: "''"
}

.emphasize {
	font-weight: bold;
}

.lineHeader {
	font-weight: bold;
}

/*PUBLICATIONS - end*/




/*DOCBOOK*/

#docbook {
/*	font: 9pt Times New Roman, Verdana, Tahoma, Arial, Helvetica, sans-serif;*/
}

.revhistory {
	display: none;
}

h2 {
	font-size: 12pt;
	font-weight: 200;
	letter-spacing: 2px;
}

h3 {
	font-size: 10pt;
	font-weight: 200;
	letter-spacing: 2px;
}

hr {
	display: none;
}

/*DOCBOOK - end*/


/* LINKS */

A:link {
	COLOR: #000099;
	TEXT-DECORATION: none;
}

A:visited {
	COLOR: #000099;
	TEXT-DECORATION: none;
}

A:hover {
	COLOR: #883333;
	TEXT-DECORATION: none;
}

A:active {
	COLOR: blue;
	TEXT-DECORATION: none;
}
'! !

!KzMenuInfoBodySite class methodsFor: 'initialization' stamp: ''!
generate
	"self generate"
	self new generate! !

!KzMenuInfoBodySite methodsFor: 'initialize' stamp: ''!
bibSetFromFile: inputFile
	"self new createBibSetFromPath: 'rmod.bib'"
	
	bibSet  := CZFileLoader bibFromFileNamed: inputFile.! !

!KzMenuInfoBodySite methodsFor: 'accessing' stamp: ''!
block
	| block |
	block := KZRightBlock new.
	self buildBlockBodyOn: block.
	self declare: block withId: #block.
	^ block! !

!KzMenuInfoBodySite methodsFor: 'block' stamp: ''!
buildBlockBodyOn: block
	block addElement: self imageItem.
	block addElement: self inriaBlockItem.
	block addElement: self rmodBlockItem.
	block addElement: self mailToBlockItem! !

!KzMenuInfoBodySite methodsFor: 'custom-points' stamp: ''!
buildMenuBodyOn: menu
	"Subclasses can change the menu items simply by changing this method"

	menu addElement: self homeMenuItem.
	menu addElement: self pharoMenuItem.
	menu addElement: self coordinatesMenuItem! !

!KzMenuInfoBodySite methodsFor: 'custom-points' stamp: ''!
buildOtherPages

	! !

!KzMenuInfoBodySite methodsFor: 'custom-points' stamp: ''!
buildWelcomePageSectionsOn: welcomePage
	welcomePage addElementInMain: self sectionCurrentJob.
	welcomePage addElementInMain: self sectionNews.	
	! !

!KzMenuInfoBodySite methodsFor: 'elements' stamp: ''!
coordinatesBody

	| section | 
	section := KZSection new title: 'Snail Mail' ; text: self coordinatesText.
	self declare: section withId: #secCoordinates.
	^ section! !

!KzMenuInfoBodySite methodsFor: 'elements' stamp: ''!
coordinatesFileName.
	^ 'Coordinates'! !

!KzMenuInfoBodySite methodsFor: 'menu' stamp: ''!
coordinatesMenuItem
	^ KZMenuItem new
		name: 'Coordinates';
		link: self coordinatesFileName, '.html';
		yourself! !

!KzMenuInfoBodySite methodsFor: 'elements' stamp: ''!
coordinatesName
	"Returns the title of the coordinates page"
	
	^ 'Coordinates'! !

!KzMenuInfoBodySite methodsFor: 'elements' stamp: ''!
coordinatesPage
	| coordinatePage |
	coordinatePage := KZPage name: self coordinatesName filename: self coordinatesFileName.
	self declarePage: coordinatePage withId: #coordinatesPage.
	coordinatePage addElement: self menu.
	coordinatePage addElementInMain: self block.
	coordinatePage addElementInMain: self coordinatesBody.
	^ coordinatePage! !

!KzMenuInfoBodySite methodsFor: 'elements' stamp: ''!
coordinatesText

	^ 'Pay attention my snail mail address is not where my office is. If you want to 
	visit me <A href="http://rmod.lille.inria.fr/">check that page</a>.
	
	Pay attention that you really put INRIA in the address. 
	
	<p>Address: <br>
		INRIA - S. Ducasse, 40, avenue Halley, <br>
		Parc Scientifique de la Haute Borne, <br>
		Bat.A, Park Plaza <br
		Villeneuve d''Ascq  59650 <br>
		France <br>
		Tel:33 (0)3 20 43 42 56<br>
		Fax:33 (0)3 59 57 78 50<br>
    </p>'
! !

!KzMenuInfoBodySite methodsFor: 'accessing' stamp: ''!
cssDirectoryName
	^ cssDirectoryName! !

!KzMenuInfoBodySite methodsFor: 'accessing' stamp: ''!
cssDirectoryName: aString
	cssDirectoryName := aString! !

!KzMenuInfoBodySite methodsFor: 'custom-points-who' stamp: ''!
cssFile
	^ self cssDirectoryName, FileDirectory slash, self cssFilename! !

!KzMenuInfoBodySite methodsFor: 'accessing' stamp: ''!
cssFilename

	^ cssFilename! !

!KzMenuInfoBodySite methodsFor: 'accessing' stamp: ''!
cssFilename: aString
	cssFilename := aString! !

!KzMenuInfoBodySite methodsFor: 'custom-points-who' stamp: ''!
currentJobText

	^ 'I''m ZZZ and I have a lot of fun doing KKK .' ! !

!KzMenuInfoBodySite methodsFor: 'custom-points' stamp: ''!
currentSectionTitle
	^ 'Current Situation'! !

!KzMenuInfoBodySite methodsFor: 'operations' stamp: ''!
declarePage: aPage withId: aSymbol

	super declarePage: aPage withId: aSymbol.
	self defineInformationOfPage: aPage.
	! !

!KzMenuInfoBodySite methodsFor: 'elements' stamp: ''!
defineInformationOfPage: welcomePage
	welcomePage title: self title.
	welcomePage cssFile: self cssFile.
	welcomePage headerSiteTitle: self headerSiteTitle.
	! !

!KzMenuInfoBodySite methodsFor: 'custom-points' stamp: ''!
generate
	"Generate the directory for the CSS and the default CSS."
	self installCSS.
	super generate.! !

!KzMenuInfoBodySite methodsFor: 'custom-points-who' stamp: ''!
headerSiteTitle

	^ 'Ze great title'
	! !

!KzMenuInfoBodySite methodsFor: 'menu' stamp: ''!
homeMenuItem
	^ KZMenuItem new
		name: 'Home';
		link: 'index.html';
		yourself! !

!KzMenuInfoBodySite methodsFor: 'block' stamp: ''!
imageItem
	^ KZImage new
		image: self imageName;
		yourself! !

!KzMenuInfoBodySite methodsFor: 'custom-points' stamp: ''!
imageName
	^ 'PictureToBeDisplayedIn128Pixels.jpg'! !

!KzMenuInfoBodySite methodsFor: 'initialize' stamp: ''!
initialize
	super initialize.
	self cssFilename: 'CSS'.
	self cssDirectoryName: 'CSS.css'.
	! !

!KzMenuInfoBodySite methodsFor: 'block' stamp: ''!
inriaBlockItem
	^ KZBlockItem new
		name: 'INRIA';
		link: 'http://www.inria.fr/';
		yourself! !

!KzMenuInfoBodySite methodsFor: 'initialize' stamp: 'StephaneDucasse 4/19/2012 22:22'!
installCSS

	| wk |
	wk := FileSystem disk workingDirectory.
	(wk / self cssDirectoryName) ensureDirectory.
	(wk / self cssDirectoryName / self cssFilename) writeStreamDo: 
		[:st | st nextPutAll: self class defaultCSS ]! !

!KzMenuInfoBodySite methodsFor: 'custom-points-who' stamp: ''!
mailText
	^ 'XXXX(@At@)YYYY.HHH'! !

!KzMenuInfoBodySite methodsFor: 'mail' stamp: ''!
mailToBlockItem
	^ KZBlockItem new
		name: self mailText;
		link: self mailtoString;
		yourself! !

!KzMenuInfoBodySite methodsFor: 'custom-points-who' stamp: ''!
mailtoString
	^ 'mailto:real.address@foo.bar'! !

!KzMenuInfoBodySite methodsFor: 'accessing' stamp: ''!
menu
	| menu |
	menu := KZMenu new.
	self buildMenuBodyOn: menu.
	self declare: menu withId: #menu.
	^ menu! !

!KzMenuInfoBodySite methodsFor: 'custom-points' stamp: ''!
newsSectionTitle
	^ 'News'! !

!KzMenuInfoBodySite methodsFor: 'custom-points' stamp: ''!
newsText

	^ '<div class="itemizedlist"> 
      <ul type="disc"> 
		<li>I attended <a href="http://www.esug.org/wiki/pier/Conferences/2011"> ESUG 2011</a>. </li>
	 	<li><a href="http://www.pharo-project.org/">Pharo</a> is cool!!</li>
	
	  </ul>
    </div>'! !

!KzMenuInfoBodySite methodsFor: 'menu' stamp: ''!
pharoMenuItem
	^ KZMenuItem new
		name: 'Pharo';
		link: 'http://www.pharo-project.org';
		yourself! !

!KzMenuInfoBodySite methodsFor: 'publications' stamp: ''!
publicationBuilderClass
	
	^ CZSingleAuthorDocBuilder! !

!KzMenuInfoBodySite methodsFor: 'publications' stamp: 'StephaneDucasse 3/23/2012 21:17'!
publicationPage
	| publicationPage doc |
	publicationPage := KZPage  name: 'Publications' filename: 'Publications'.
	self declarePage: publicationPage withId: #publicationPage.
	publicationPage addElement: self menu.
	publicationPage addElementInMain: self block.
	
	doc := self publicationBuilderClass new
				bibset: bibSet;
				setFilteringOn.
	publicationPage addElementInMain: doc build document.
	^ publicationPage! !

!KzMenuInfoBodySite methodsFor: 'block' stamp: ''!
rmodBlockItem
	^ KZBlockItem new
		name: 'RMOD';
		link: 'http://rmod.lille.inria.fr/';
		yourself! !

!KzMenuInfoBodySite methodsFor: 'elements' stamp: ''!
sectionCurrentJob
	| section |
	section := KZSection new
		title: self currentSectionTitle;
		text: self currentJobText.
	self declare: section withId: #secCurrentJob.
	^ section! !

!KzMenuInfoBodySite methodsFor: 'elements' stamp: ''!
sectionNews
	| section |
	section := KZSection new
		title: self newsSectionTitle;
		text: self newsText.
	self declare: section withId: #secNews.
	^ section! !

!KzMenuInfoBodySite methodsFor: 'custom-points' stamp: 'StephaneDucasse 3/23/2012 21:19'!
site
	"self site"
	
	self welcomePage.
	self coordinatesPage.
	self buildOtherPages.
	self publicationPage. 
	^ self
	! !

!KzMenuInfoBodySite methodsFor: 'custom-points-who' stamp: ''!
title 

	^ 'Dr. St&eacute;phane Ducasse' ! !

!KzMenuInfoBodySite methodsFor: 'custom-points' stamp: ''!
welcomeName
	^ 'Home'! !

!KzMenuInfoBodySite methodsFor: 'elements' stamp: ''!
welcomePage
	| welcomePage |
	welcomePage := KZPage  name: self welcomeName filename: 'index'.
	self declarePage: welcomePage withId: #welcomePage.
	welcomePage addElement: self menu.
	welcomePage addElementInMain: self block.
	self buildWelcomePageSectionsOn: welcomePage.
	^ welcomePage! !

Object subclass: #KZVisitor
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZVisitor commentStamp: 'StephaneDucasse 1/1/2012 22:52' prior: 0!
ARVisitor is a web site visitor. !

!KZVisitor methodsFor: 'private' stamp: ''!
addComment: aComment
	stream 
		nextPutAll: '    <!!--'; 
		nextPutAll: aComment; 
		nextPutAll: ' -->'.
	! !

!KZVisitor methodsFor: 'default' stamp: ''!
bodyEncodings
	^ 'body'! !

!KZVisitor methodsFor: 'operation' stamp: ''!
contents

	^ stream contents! !

!KZVisitor methodsFor: 'private' stamp: ''!
cr

	stream nextPut: Character cr! !

!KZVisitor methodsFor: 'private' stamp: ''!
div

	self startBalise: 'div'! !

!KZVisitor methodsFor: 'default' stamp: ''!
divEncodings
	^ 'div'! !

!KZVisitor methodsFor: 'private' stamp: ''!
endBalise: aString

	stream nextPut: $< ; nextPut: $/.
	stream nextPutAll: aString.
	stream nextPut: $>. 
	

	! !

!KZVisitor methodsFor: 'private' stamp: ''!
endBaliseCr: aString

	self endBalise: aString.
	self cr.
	

	! !

!KZVisitor methodsFor: 'private' stamp: ''!
endBody

	self endBalise: 'body'.! !

!KZVisitor methodsFor: 'private' stamp: ''!
endDiv

	self endBalise: 'div'! !

!KZVisitor methodsFor: 'operation' stamp: ''!
ensureAttribute: aKey value: aTag div: aBlock
	"ensureDiv: aBlock key: id tagged: menu ->
		div id='menu'"

	self startBalise: self divEncodings attribute: aKey value: aTag.
	aBlock cull: stream.
	self endDiv.
	self addComment: 'Closing ' , aTag.
	self cr! !

!KZVisitor methodsFor: 'operation' stamp: ''!
ensureBody: aBlock
	self startBalise: self bodyEncodings.
	aBlock cull: stream.
	self endBalise: self bodyEncodings! !

!KZVisitor methodsFor: 'operation' stamp: ''!
ensureDiv: aBlock
	
	self div.
	aBlock value: stream.
	self endDiv! !

!KZVisitor methodsFor: 'operation' stamp: ''!
ensureIdValue: aTag div: aBlock
	"ensureDiv: aBlock key: id tagged: menu ->
		div id='menu'"

	self startBalise: self divEncodings attribute: 'id' value: aTag.
	self cr.
	aBlock cull: stream.
	self endDiv.
	self addComment: 'Closing ' , aTag.
	! !

!KZVisitor methodsFor: 'private' stamp: ''!
ensureTag: aString for: aBlock

	self startBalise: aString.
	aBlock value: stream.
	self endBalise: aString! !

!KZVisitor methodsFor: 'default' stamp: ''!
headerEncodings
	^ 'header'! !

!KZVisitor methodsFor: 'default' stamp: ''!
headerPageTitleEncodings
	^ 'headerPageTitle'! !

!KZVisitor methodsFor: 'default' stamp: ''!
headerSideTitleEncodings
	^ 'headerSideTitle'! !

!KZVisitor methodsFor: 'private' stamp: ''!
href: url name: aString

	stream 
		nextPutAll: '<a href="';
		nextPutAll: url;
		nextPutAll: '">';
		nextPutAll: aString;
		nextPutAll: '</a>'! !

!KZVisitor methodsFor: 'visit' stamp: ''!
mainContentEncodings
	^ 'mainContent'! !

!KZVisitor methodsFor: 'default' stamp: ''!
menuEncodings
	^ 'menu'! !

!KZVisitor methodsFor: 'visit' stamp: ''!
newFileFor: aPage
	^ FileStream forceNewFileNamed: aPage filename! !

!KZVisitor methodsFor: 'default' stamp: ''!
personalDetailsEncodings
	^ 'personalDetails'! !

!KZVisitor methodsFor: 'default' stamp: ''!
personalDetailsItemEncodings
	^ 'personalDetailsItem'! !

!KZVisitor methodsFor: 'private' stamp: ''!
startBalise: aString

	stream nextPut: $<.
	stream nextPutAll: aString.
	stream nextPut: $>.
	stream nextPut: Character cr.

	! !

!KZVisitor methodsFor: 'private' stamp: ''!
startBalise:  balise attribute: aKey value: aTag.
	
	stream 
		nextPut: $<; 
		nextPutAll: balise ; 
		nextPut: Character space ; 
		nextPutAll: aKey ; 
		nextPutAll: '="' ; 
		nextPutAll: aTag; 
		nextPutAll: '">'.! !

!KZVisitor methodsFor: 'private' stamp: ''!
startBody

	self startBalise: 'body'.! !

!KZVisitor methodsFor: 'default' stamp: ''!
tocEncodings
	^ 'toc'! !

!KZVisitor methodsFor: 'default' stamp: ''!
tocItemEncodings
	^ 'tocItem'! !

!KZVisitor methodsFor: 'visit' stamp: ''!
visit: anElement

	anElement acceptVisitor: self! !

!KZVisitor methodsFor: 'visit' stamp: ''!
visitBibItemCollection: aBibItemCollection
	
	self ensureTag: 'ol' for: [:aStream | 
		CZHTMLGenerator new 
			outputStream: aStream;
			visit: (CZSet new addAll: aBibItemCollection elements ; yourself)]
		! !

!KZVisitor methodsFor: 'visit citezen' stamp: ''!
visitBibSet: aCZSet

	self visitBibItemCollection: aCZSet entries.! !

!KZVisitor methodsFor: 'visit' stamp: ''!
visitDivBlock: aBlock

	self
		ensureIdValue: self mainContentEncodings
		div: [ aBlock elements do: [ :each | self visit: each ] separatedBy: [ stream cr ] ]! !

!KZVisitor methodsFor: 'visit citezen' stamp: ''!
visitDoc: aCZDocument

	aCZDocument elements do: [:each |
			CZHTMLGenerator new 
				outputStream: stream;
				visit: each]! !

!KZVisitor methodsFor: 'visit' stamp: ''!
visitImage: aLinkedImage

	self ensureDiv: [ :aStream | 
			aStream 
				nextPutAll: '<img src="'; nextPutAll: aLinkedImage image; 
				nextPutAll: '">' ; 
				nextPut: Character cr]! !

!KZVisitor methodsFor: 'visit' stamp: ''!
visitItem: anItem

	self ensureTag: 'li' for: [:aStream | 
							aStream 
								nextPutAll: '<a href="'; 
								nextPutAll: anItem link;
								nextPutAll: '">';
								nextPutAll: anItem name].
	stream cr.! !

!KZVisitor methodsFor: 'visit' stamp: ''!
visitItemList: aList

	self ensureAttribute: 'class'
			 value: 'itemizedlist'
			 div: [
				self ensureTag: 'ul' for: 
					[ :aStream | aList elements do: [:each | self visit: each ] ] ]! !

!KZVisitor methodsFor: 'visit' stamp: ''!
visitLinkedImage: anImage

	self ensureDiv: [ :aStream | 
			aStream 
				nextPutAll: '<a href="'; 
				nextPutAll: anImage link; 
				nextPutAll: '"><img src="'; nextPutAll: anImage image; 
				nextPutAll: '"></a>' ; 
				nextPut: Character cr]! !

!KZVisitor methodsFor: 'visit' stamp: ''!
visitMenu: aMenu
	self
		ensureIdValue: self menuEncodings
		div: [ 
			self
				ensureIdValue: self tocEncodings
				div: [ aMenu elements do: [ :each | self visit: each ] 
											separatedBy: [ stream cr ] ] ]! !

!KZVisitor methodsFor: 'visit' stamp: ''!
visitMenuItem: aMenuItem
	self ensureIdValue: self tocItemEncodings div: [ self href: aMenuItem link name: aMenuItem name ]! !

!KZVisitor methodsFor: 'visit' stamp: ''!
visitPage: aPage
	
	[stream := self newFileFor: aPage.
	stream nextPutAll: aPage metaHead.
	stream nextPutAll: aPage head.
	self
		ensureBody: [ 
			self
				ensureIdValue: self headerEncodings
				div: [ 
					self ensureIdValue: self headerSideTitleEncodings div: [ stream nextPutAll: aPage headerSiteTitle ].
					self ensureIdValue: self headerPageTitleEncodings div: [ stream nextPutAll: aPage headerPageTitle ]].
			aPage elements do: [ :each | self visit: each ].
			self ensureIdValue: self mainContentEncodings div: [ 
					aPage main elements do: [ :each | self visit: each ]]			
			]]
		ensure: [stream close]! !

!KZVisitor methodsFor: 'visit' stamp: ''!
visitRightBlock: aBlock
	self
		ensureIdValue: self personalDetailsEncodings
		div: [ aBlock elements do: [ :each | self visit: each ] separatedBy: [ stream cr ] ]! !

!KZVisitor methodsFor: 'visit' stamp: ''!
visitRightBlockItem: anItem
	self ensureIdValue: self personalDetailsItemEncodings div: [ self href: anItem link name: anItem name ]! !

!KZVisitor methodsFor: 'visit' stamp: ''!
visitSection: aSection

	stream
		nextPutAll:  '<h';
		nextPutAll: aSection levelDigitString;
		nextPutAll: '><b><a NAME="';
		nextPutAll: aSection title;
		nextPutAll: '">';
		nextPutAll: aSection title;
		nextPutAll: '</a></b></h';
		nextPutAll: aSection levelDigitString;
		nextPutAll: '>';
		nextPutAll:  aSection text.! !

!KZVisitor methodsFor: 'visit' stamp: ''!
visitSite: aSite

	aSite pages do: [:each | self visit: each].! !

Object subclass: #ManifestKozen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!ManifestKozen class methodsFor: 'meta data' stamp: ''!
rejectClasses
^ #()! !

!ManifestKozen class methodsFor: 'meta data' stamp: ''!
rejectRules
^ #(78 24 115)! !

!ManifestKozen class methodsFor: 'meta data' stamp: ''!
rule105V1TruePositive
^ #(#('(RGMethodDefinition className: ''KZPage'' selector: #filename isMetaSide: false)' #(#'15 March 2012' #'9:14:12 am')) )! !

!ManifestKozen class methodsFor: 'meta data' stamp: ''!
rule108V1TruePositive
^ #(#('(RGMethodDefinition className: ''KZVisitor'' selector: #visitItem: isMetaSide: false)' #(#'15 March 2012' #'9:36:38 am')) #('(RGMethodDefinition className: ''KZVisitor'' selector: #visitSection: isMetaSide: false)' #(#'15 March 2012' #'9:38:37 am')) )! !

!ManifestKozen class methodsFor: 'meta data' stamp: ''!
rule15V1FalsePositive
^ #(#('(RGClassDefinition named: #KZVisitor)' #(#'15 March 2012' #'9:56:29 am')) #('(RGClassDefinition named: #KzMenuInfoBodySite)' #(#'15 March 2012' #'9:56:43 am')) )! !

!ManifestKozen class methodsFor: 'meta data' stamp: ''!
rule17V1TODO
^ #(#('(RGMethodDefinition className: ''String'' selector: #deDoubleSingleQuotes isMetaSide: false)' #(#'22 March 2012' #'4:17:29 pm')) #('(RGMethodDefinition className: ''StefSite'' selector: #bibBuilder: isMetaSide: false)' #(#'22 March 2012' #'4:17:29 pm')) #('(RGMethodDefinition className: ''KZVisitor'' selector: #endBody isMetaSide: false)' #(#'22 March 2012' #'4:17:29 pm')) #('(RGMethodDefinition className: ''KZObject'' selector: #siteId isMetaSide: false)' #(#'22 March 2012' #'4:17:29 pm')) #('(RGMethodDefinition className: ''StefSite'' selector: #keywordsText isMetaSide: false)' #(#'22 March 2012' #'4:17:29 pm')) #('(RGMethodDefinition className: ''StefSite class'' selector: #bibEntriesWithoutKzAnnotation isMetaSide: true)' #(#'22 March 2012' #'4:17:29 pm')) #('(RGMethodDefinition className: ''KZVisitor'' selector: #endBaliseCr: isMetaSide: false)' #(#'22 March 2012' #'4:17:29 pm')) #('(RGMethodDefinition className: ''KZObject'' selector: #siteId: isMetaSide: false)' #(#'22 March 2012' #'4:17:29 pm')) #('(RGMethodDefinition className: ''StefSite'' selector: #bibBuilder isMetaSide: false)' #(#'22 March 2012' #'4:17:29 pm')) #('(RGMethodDefinition className: ''KZSite'' selector: #addPage: isMetaSide: false)' #(#'22 March 2012' #'4:17:29 pm')) #('(RGMethodDefinition className: ''KZVisitor'' selector: #startBody isMetaSide: false)' #(#'22 March 2012' #'4:17:29 pm')) )! !

!ManifestKozen class methodsFor: 'meta data' stamp: ''!
rule18V1TODO
^ #(#('(RGClassDefinition named: #KZList)' #(#'22 March 2012' #'4:18:06 pm')) #('(RGClassDefinition named: #KZSite)' #(#'22 March 2012' #'4:18:06 pm')) #('(RGClassDefinition named: #Object)' #(#'22 March 2012' #'4:18:06 pm')) #('(RGClassDefinition named: #KZObject)' #(#'22 March 2012' #'4:18:06 pm')) #('(RGClassDefinition named: #KZPage)' #(#'22 March 2012' #'4:18:06 pm')) #('(RGClassDefinition named: #KZMenuItem)' #(#'22 March 2012' #'4:18:06 pm')) #('(RGClassDefinition named: #KZSection)' #(#'22 March 2012' #'4:18:06 pm')) #('(RGClassDefinition named: #KZLinkedImage)' #(#'22 March 2012' #'4:18:06 pm')) #('(RGClassDefinition named: #ProtoObject)' #(#'22 March 2012' #'4:18:06 pm')) #('(RGClassDefinition named: #KZDivBlock)' #(#'22 March 2012' #'4:18:06 pm')) #('(RGClassDefinition named: #StefSite)' #(#'22 March 2012' #'4:18:06 pm')) #('(RGClassDefinition named: #KZItem)' #(#'22 March 2012' #'4:18:06 pm')) #('(RGClassDefinition named: #KZImage)' #(#'22 March 2012' #'4:18:06 pm')) #('(RGClassDefinition named: #KzMenuInfoBodySite)' #(#'22 March 2012' #'4:18:06 pm')) )! !

!ManifestKozen class methodsFor: 'meta data' stamp: ''!
rule32V1TODO
^ #(#('(RGClassDefinition named: #KZSection)' #(#'22 March 2012' #'4:26:45 pm')) #('(RGClassDefinition named: #KZRightBlock)' #(#'22 March 2012' #'4:26:45 pm')) #('(RGClassDefinition named: #KZObject)' #(#'22 March 2012' #'4:26:45 pm')) #('(RGClassDefinition named: #KZList)' #(#'22 March 2012' #'4:26:45 pm')) #('(RGClassDefinition named: #KZItem)' #(#'22 March 2012' #'4:26:45 pm')) #('(RGClassDefinition named: #KZImage)' #(#'22 March 2012' #'4:26:45 pm')) #('(RGClassDefinition named: #KZMenu)' #(#'22 March 2012' #'4:26:45 pm')) #('(RGClassDefinition named: #KZMenuItem)' #(#'22 March 2012' #'4:26:45 pm')) #('(RGClassDefinition named: #KZLinkedImage)' #(#'22 March 2012' #'4:26:45 pm')) #('(RGClassDefinition named: #KZResearchTopic)' #(#'22 March 2012' #'4:26:45 pm')) )! !

!ManifestKozen class methodsFor: 'meta data' stamp: ''!
rule33V1TODO
^ #(#('(RGClassDefinition named: #KZResearchTopic)' #(#'22 March 2012' #'4:27:15 pm')) )! !

!ManifestKozen class methodsFor: 'meta data' stamp: ''!
rule38V1TruePositive
^ #(#('(RGMethodDefinition className: ''KzMenuInfoBodySite'' selector: #site isMetaSide: false)' #(#'15 March 2012' #'10:11:50 am')) )! !

!ManifestKozen class methodsFor: 'meta data' stamp: ''!
rule50V1FalsePositive
^ #(#('(RGMethodDefinition className: ''KZVisitor'' selector: #newFileFor: isMetaSide: false)' #(#'15 March 2012' #'10:17:16 am')) #('(RGMethodDefinition className: ''Citeseer'' selector: #getRankFrom:stoppingAt: isMetaSide: false)' #(#'15 March 2012' #'10:17:16 am')) #('(RGMethodDefinition className: ''KZSite'' selector: #acceptVisitor: isMetaSide: false)' #(#'22 March 2012' #'4:30:17 pm')) )! !

!ManifestKozen class methodsFor: 'meta data' stamp: ''!
rule71V1TODO
^ #(#('(RGMethodDefinition className: ''KZVisitor'' selector: #visitPage: isMetaSide: false)' #(#'22 March 2012' #'4:17:08 pm')) )! !

!ManifestKozen class methodsFor: 'meta data' stamp: ''!
rule76V1FalsePositive
^ #(#('(RGMethodDefinition className: ''KZPage'' selector: #head isMetaSide: false)' #(#'15 March 2012' #'10:03:20 am')) )! !

!ManifestKozen class methodsFor: 'meta data' stamp: ''!
rule79V1TODO
^ #(#('(RGMethodDefinition className: ''KzMenuInfoBodySite'' selector: #sectionCurrentJob isMetaSide: false)' #(#'22 March 2012' #'4:24:04 pm')) #('(RGMethodDefinition className: ''KZPage'' selector: #initialize isMetaSide: false)' #(#'22 March 2012' #'4:24:04 pm')) #('(RGMethodDefinition className: ''KzMenuInfoBodySite'' selector: #sectionNews isMetaSide: false)' #(#'22 March 2012' #'4:24:04 pm')) #('(RGMethodDefinition className: ''Citeseer'' selector: #getCiteseerPage isMetaSide: false)' #(#'22 March 2012' #'4:24:04 pm')) #('(RGMethodDefinition className: ''KzMenuInfoBodySite'' selector: #coordinatesBody isMetaSide: false)' #(#'22 March 2012' #'4:24:04 pm')) )! !

!ManifestKozen class methodsFor: 'meta data' stamp: ''!
rule87V1TODO
^ #(#('(RGMethodDefinition className: ''Citeseer'' selector: #getCiteseerPage isMetaSide: false)' #(#'22 March 2012' #'4:28:20 pm')) )! !

!ManifestKozen class methodsFor: 'meta data' stamp: ''!
rule8V1FalsePositive
^ #(#('(RGClassDefinition named: #ManifestKozen)' #(#'15 March 2012' #'9:51:37 am')) #('(RGClassDefinition named: #KZResearchTopic)' #(#'15 March 2012' #'9:54:13 am')) #('(RGClassDefinition named: #KZLinkedImage)' #(#'22 March 2012' #'4:14:45 pm')) )! !

!String methodsFor: '*kozen' stamp: ''!
deDoubleSingleQuotes
	"transform two subsequent single quotes into one"
	
	"'abcdebcdg' . 'bc' .'z' ->  'azdezdg' but the same with '' and '"
	
	^ self copyReplaceAll: (String with: $' with: $')  with: (String with: $') 
	! !
